/*
 * =====================================================================================
 *
 *       Filename:  display.h
 *
 *    Description:  Headers for display routines 
 *
 *        Version:  1.0
 *        Created:  15/03/2017 20:07:12
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Jerome Benoit (fraggle), jerome.benoit@piment-noir.org
 *   Organization:  Piment Noir
 *
 * =====================================================================================
 */

#ifndef DISPLAY_H
#define DISPLAY_H

#include "coordinates.h"

/* ncurses printing */
void print_board(int y, int x);
void print_coordinates(coordinates_t coordinates_array[], int base_y, int base_x);

/* non ncurses printing */

#endif /* DISPLAY_H */
